using System;
using System.Collections.Generic;
using System.Text;
using IronPython.Hosting;

namespace IronPythonMemory
{
	class Program
	{
		static void Main(string[] args)
		{
		//	IronPython.AST.Options.FastEval = true;

			Console.WriteLine("Ready");
			Console.ReadKey();

			for (int i = 0; i < 100; i++)
			{
				TestPython pyth = new TestPython();
				pyth.TestExecute(i.ToString());

				//pyth.TestEvaluate(i.ToString());
			}

			GC.Collect();


			Console.WriteLine("Done.");
			Console.WriteLine("Now run WinDbg and see that Frame objects are hanging in some static object[] array.");
			Console.ReadKey();
		}
	}

	public class TestPython
	{
		public object TestEvaluate(string testValue)
		{
			PythonEngine engine = new PythonEngine();
			engine.SetVariable("foo", testValue);
			string script = " 'foo= ' + '" + testValue +"'";
			return engine.Evaluate(script);
		}

		public object TestExecute(string testValue)
		{
			PythonEngine engine = new PythonEngine();
			engine.SetVariable("foo", testValue);
			string script = " 'foo= ' + '" + testValue + "'";
			engine.Execute(script);
			return engine.GetVariable("_");
		}
	}
}
